////////////////////////////////////////////////////////////////////////////////
// Copyright  1992 Apple Computer, Inc. All rights reserved.				  //
////////////////////////////////////////////////////////////////////////////////

#include "Types.r"		/* must come before AEUserTermTypes.r */
#include "AEUserTermTypes.r"
#include "AppleEvents.r"
#include "AEObjects.r"
#include "AERegistry.r"


resource 'aeut' (0, "Miscellaneous Standards Terminology", sysheap) {
	0x00,
	0x96,
	english,
	roman,
	{	/* array Suites: 1 element */
		"Miscellaneous Standards",
		"Miscellaneous standard events and classes",
		kAEMiscStandards,
		1,
		1,
		{	/* array Events: 0 elements */
			/* [1] */
			"begin transaction",
			"Begin a transaction",
			kAEMiscStandards,
			kAEBeginTransaction,
			typeLongInteger,
			"",
			replyRequired,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			noParams,
			"",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [2] */
			"end transaction",
			"End a transaction",
			kAEMiscStandards,
			kAEEndTransaction,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			noParams,
			"",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [3] */
			"create publisher",
			"Create a publisher",
			kAEMiscStandards,
			kAECreatePublisher,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			typeObjectSpecifier,
			"Object to publish",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 1 elements */
				/* [1] */
				"edition",
				keyAEEditionFileLoc,
				typeAlias,
				"Alias to the edition container file",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved
			},
			/* [4] */
			"cut",
			"Cut an object to the clipboard",
			kAEMiscStandards,
			kAECut,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			noParams,
			"",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [5] */
			"copy",
			"Copy an object to the clipboard",
			kAEMiscStandards,
			kAECopy,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			noParams,
			"",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [6] */
			"paste",
			"Paste an object from the clipboard",
			kAEMiscStandards,
			kAEPaste,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			noParams,
			"",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [7] */
			"edit graphic",
			"Edit the specified drawing area",
			kAEMiscStandards,
			kAEEditGraphic,
			typeDrawingArea,
			"",
			replyRequired,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			typeDrawingArea,
			"the drawing area to be edited",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [8] */
			"image graphic",
			"Convert a graphic from one format to another",
			kAEMiscStandards,
			kAEImageGraphic,
			typeWildCard,
			"",
			replyRequired,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			typeWildCard,
			"the graphic to be converted or formatted",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 10 elements */
				/* [1] */
				"antialiasing",
				keyAEDoAntiAlias,
				typeBoolean,
				"use antialiasing",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [2] */
				"dithering",
				keyAEDoDithered,
				typeBoolean,
				"use dithering",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [3] */
				"rotate",
				keyAEDoRotate,
				typeRotation,
				"the rotation of the image",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [4] */
				"scale",
				keyAEDoScale,
				typeFixed,
				"the factor by which to scale the image",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [5] */
				"translation",
				keyAEDoTranslate,
				typeQDPoint,
				"offset by which the image should be moved",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [6] */
				"flip horizontal",
				keyAEFlipHorizontal,
				typeBoolean,
				"flip image horizontally?",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [7] */
				"flip vertical",
				keyAEFlipVertical,
				typeBoolean,
				"flip image vertically?",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [8] */
				"quality",
				keyAEImageQuality,
				enumQuality,
				"image quality of the result",
				optional,
				singleItem,
				enumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [9] */
				"format",
				keyAERenderAs,
				typeType,
				"The format into which the data should be imaged",
				required,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [10] */
				"structured graphic",
				keyAETryAsStructGraf,
				typeBoolean,
				"Return a structured graphic, instead of a pixel map?",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
			},
			/* [9] */
			"uniform",
			"Is the value of the specified property the same for all objects in the set?",
			kAEMiscStandards,
			kAEIsUniform,
			typeBoolean,
			"",
			replyRequired,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			typeObjectSpecifier,
			"The set of objects to be checked for uniformity",
			directParamRequired,
			singleItem,
			notEnumerated,
			doesntChangeState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 1 elements */
				/* [1] */
				"in",
				keyAEProperty,
				typeType,
				"The property ID for the property to be checked",
				required,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
			},
			/* [9] */
			"show",
			"Bring an object into view",
			kAEMiscStandards,
			kAEMakeObjectsVisible,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			typeObjectSpecifier,
			"the object to be made visible",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 1 elements */
				/* [1] */
				"in",
				keyAEWindow,
				typeObjectSpecifier,
				"the window in which to display the object",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				/* [2] */
				"at",
				keyAEShowWhere,
				typeQDPoint,
				"the point at which to display the object",
				optional,
				singleItem,
				notEnumerated,
				reserved,
				reserved, reserved, reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved, reserved
			},
			/* [10] */
			"redo",
			"Reverse the action of the immediately preceeding undo",
			kAEMiscStandards,
			kAERedo,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			noParams,
			"",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [11] */
			"revert",
			"Restore the object to its last saved state",
			kAEMiscStandards,
			kAERevert,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			typeObjectSpecifier,
			"The object to revert",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [12] */
			"undo",
			"Undo the action of the previous event or user interaction",
			kAEMiscStandards,
			kAEUndo,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			noParams,
			"",
			directParamOptional,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
			/* [13] */
			"select",
			"Select object(s)",
			kAEMiscStandards,
			kAESelect,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved, reserved,
			typeObjectSpecifier,
			"Object(s) to select",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			reserved, reserved, reserved, reserved, reserved, reserved,
			reserved, reserved, reserved, reserved, reserved, reserved,
			{	/* array OtherParams: 0 elements */
			},
		},
		{	/* array Classes: 3 elements */
			/* [1] */
			"text item",
			cItem,
			"a text item",
			{	/* array Properties: 9 elements */
				/* [1] */
				"best type",
				pBestType,
				cType,
				"the best descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [2] */
				"class",
				pClass,
				cType,
				"the class",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved, 
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [3] */
				"color",
				pColor,
				cRGBColor,
				"The color of the first character",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [4] */
				"default type",
				pDefaultType,
				cType,
				"the default descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [5] */
				"font",
				pFont,
				cText,
				"the name of the font of the first character",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [6] */
				"size",
				pPointSize,
				cFixed,
				"the size in points of the first character",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [7] */
				"writing code",
				pScriptTag,
				cIntlWritingCode,
				"The script system and language",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [8] */
				"style",
				pTextStyles,
				cTextStyles,
				"the text style of the first character",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [9] */
				"uniform styles",
				pUniformStyles,
				cTextStyles,
				"the text styles that are uniform throughout the item",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
			},
			{	/* array Elements: 2 elements */
				/* [1] */
				cChar,
				{	/* array KeyForms: 1 element */
					formAbsolutePosition
				},
				/* [2] */
				cText,
				{	/* array KeyForms: 1 element */
					formAbsolutePosition
				}
			},
			"text items",
			cItem,
			"Every text item",
			{	/* array Properties: 1 elements */
				/* [1] */
				"class attributes",
				kAESpecialClassProperties,
				cType,
				"The best descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [2] */
			"menu",
			cMenu,
			"A menu",
			{	/* array Properties: 5 elements */
				/* [1] */
				"best type",
				pBestType,
				cType,
				"the best descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [2] */
				"class",
				pClass,
				cType,
				"The class",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [3] */
				"default type",
				pDefaultType,
				cType,
				"the default descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [4] */
				"menu ID",
				pMenuID,
				cShortInteger,
				"the menu ID for the menu",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [5] */
				"name",
				pName,
				cIntlText,
				"the name",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
			},
			{	/* array Elements: 1 elements */
				cMenuItem,
				{	/* array KeyForms: 1 element */
					formAbsolutePosition,
					formName,
				},
			},
			"menus",
			cMenu,
			"Every menu",
			{	/* array Properties: 1 elements */
				"class attributes",
				kAESpecialClassProperties,
				cType,
				"the best descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [3] */
			"menu item",
			cMenuItem,
			"A menu item",
			{	/* array Properties: 5 elements */
				/* [1] */
				"best type",
				pBestType,
				cType,
				"The best descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [2] */
				"class",
				pClass,
				cType,
				"the class",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [3] */
				"default type",
				pDefaultType,
				cType,
				"the default descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [4] */
				"enabled",
				pEnabled,
				cBoolean,
				"Is the menu item is enabled?",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [5] */
				"item number",
				pItemNumber,
				cShortInteger,
				"the menu item number",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
				/* [6] */
				"name",
				pName,
				cIntlText,
				"The name",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				singlular,
			},
			{	/* array Elements: 0 elements */
			},
			"menu items",
			cMenuItem,
			"Every menu item",
			{	/* array Properties: 1 elements */
				"Class attributes",
				kAESpecialClassProperties,
				cType,
				"The best descriptor type",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved, reserved, reserved, reserved,
				reserved, reserved, reserved, reserved, reserved,
				notFeminine,
				notMasculine,
				plural
			},
			{	/* array Elements: 0 elements */
			},
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 1 elements */
			/* [1] */
			enumQuality,
			{	/* array Enumerators: 3 elements */
				/* [1] */
				"draft",
				kAEFast,
				"image the graphic as quickly as possible",
				/* [2] */
				"regular",
				kAERegular,
				"image the graphic normally",
				/* [3] */
				"high",
				kAEHiQuality ,
				"image the graphic at the highest quality possible"
			},
		}
	}
};
